/***************************************************************************\
*                                                                           *
*   WINDOWS.H                                                               *
*                                                                           *
*   Some headers are used from the cygnus project                           *
*   Modified by:                                                            *
*    kiefer@isys.de                                                         *
*    rainer@mathematik.uni-bielefeld.de                                     *
*									    *
\***************************************************************************/

#if !defined (_WINDOWS_H)
#define _WINDOWS_H

#ifdef __cplusplus
extern "C" {
#endif

#if defined (RC_INVOKED)
#define NOGDI
#else
#include <stdarg.h>
#endif


/* unicode stuff - minimize #ifdef */

#ifdef UNICODE
    
#define TSTRUCT(x) x##W
#define TFUNCT(x) x##W

#else /* not UNICODE */

#define TSTRUCT(x) x##A
#define TFUNCT(x) x##A

#endif

#include <wingnuc.h>
#include <windef.h>

#if !defined (NOKERNEL)
#include <winerror.h>
#include <winkerne.h>
#include <excpt.h>
#endif

#if !defined(NOUSER)
#include <winuser.h>
#endif

#if !defined (NOGDI) 
#include <wingdi.h>
#endif

#if !defined (WIN32_LEAN_AND_MEAN)
#include <winadvap.h>
#include <winversi.h>
#include <commdlg.h>
#endif

#ifdef __cplusplus
}
#endif

#endif /* !defined (_WINDOWS_H) */
